# Poco::Net

# class HTTPServerRequest

Library: Net
Package: HTTPServer
Header: Poco/Net/HTTPServerRequest.h

## Description

This abstract subclass of HTTPRequest is used for representing server-side HTTP requests.

A HTTPServerRequest is passed to the handleRequest() method of HTTPRequestHandler.

## Inheritance

Direct Base Classes: HTTPRequest

All Base Classes: HTTPMessage, HTTPRequest, MessageHeader, NameValueCollection

Known Derived Classes: HTTPServerRequestImpl

## Member Summary

Member Functions: clientAddress, expectContinue, response, serverAddress, serverParams, stream

Inherited Functions: add, begin, clear, empty, end, erase, find, get, getChunkedTransferEncoding, getContentLength, getContentType, getCookies, getCredentials, getHost, getKeepAlive, getMethod, getTransferEncoding, getURI, getVersion, has, hasCredentials, operator, operator =, quote, read, set, setChunkedTransferEncoding, setContentLength, setContentType, setCookies, setCredentials, setHost, setKeepAlive, setMethod, setTransferEncoding, setURI, setVersion, size, splitElements, splitParameters, swap, write

## Constructors

### HTTPServerRequest

HTTPServerRequest();

Creates the HTTPServerRequest

## Destructor

### ~HTTPServerRequest

~HTTPServerRequest();

Destroys the HTTPServerRequest.

## Member Functions

### clientAddress

virtual const SocketAddress & clientAddress() const = 0;

Returns the client's address.

### expectContinue

virtual bool expectContinue() const = 0;

Returns true if the client expects a 100 Continue response.

### response

virtual HTTPServerResponse & response() const = 0;

Returns a reference to the associated response.

### serverAddress

virtual const SocketAddress & serverAddress() const = 0;

Returns the server's address.

### serverParams

virtual const HTTPServerParams & serverParams() const = 0;

Returns a reference to the server parameters.

### stream

virtual std::istream & stream() = 0;

Returns the input stream for reading the request body.

The stream must be valid until the HTTPServerRequest object is destroyed.